local T, C, L, _ = unpack(select(2, ...))
if C.trade.auto_buy ~= true then return end

--------------------------------------------------------------------------------------
--  Auto Buy
--------------------------------------------------------------------------------------
local function Buy()
    if IsShiftKeyDown() then return end
    if T.buy_list then
        for i = 0, GetMerchantNumItems() do
            for _, item in pairs(T.buy_list) do
                local merchName, _, _, _, NumAvailable = GetMerchantItemInfo(i)
                local itemName = GetItemInfo(item[1])
                local amountInBags = GetItemCount(item[1])
                if merchName == itemName then
                    if NumAvailable < 0 then NumAvailable = 99999 end
                    local toBuy = min(item[2] - amountInBags, NumAvailable)
                    if toBuy > 0 then
                        BuyMerchantItem(i, toBuy)
                    end
                end
            end
        end
    end
end

local BANK_BAGS = {-1,5,6,7,8,9,10,11}
local BANK_BAGS_REVERSED = {11,10,9,8,7,6,5,-1}
if REAGENTBANK_CONTAINER then
    tinsert(BANK_BAGS, REAGENTBANK_CONTAINER)
    tinsert(BANK_BAGS_REVERSED, REAGENTBANK_CONTAINER)
end
local function IsItemInList(item)
    local type
    if tonumber(item) then
        type = "itemID"
    elseif string.find(item, "Hitem:") then
        type = "itemLink"
    else
        type = "itemName"
    end

    for _, Item in ipairs(T.BankList) do
        if Item[type] == item then
            return true
        end
    end
    return false
end


local function GetItemIndex(item)
    local type
    if tonumber(item) then
        type = "itemID"
    elseif string.find(item, "Hitem:") then
        type = "itemLink"
    else
        type = "itemName"
    end

    for i, Item in ipairs(T.BankList) do
        if Item[type] == item then
        return i
        end
    end
    return nil
end

local function GetItemsInBags()
    local T = {}
    for bag = BACKPACK_CONTAINER, NUM_BAG_SLOTS do
        for slot = 1, GetContainerNumSlots(bag) do
            local _, itemCount, locked, _, _, _, itemLink, _, _, itemID = GetContainerItemInfo(bag, slot)
            local itemName = itemLink and string.match(itemLink, "%[(.*)%]")
            if itemID then
                T[itemName] = T[itemName] and T[itemName] + itemCount or itemCount
            end
        end
    end
    return T
end

local function PutSplitItemIntoBags(item, amountOnMouse)
    if not CursorHasItem() then return end
    C_NewItems.ClearAll()

    for bag = BACKPACK_CONTAINER, NUM_BAG_SLOTS do
        for slot = 1, GetContainerNumSlots(bag) do
        local _, itemCount, locked, _, _, _, _, _, _, itemID = GetContainerItemInfo(bag, slot)
            if itemID and not locked then
            local itemName, _, _, _, _, _, _, itemStackCount = GetItemInfo(itemID)
                if itemName == item.itemName and itemCount+amountOnMouse <= itemStackCount then
                    PickupContainerItem(bag, slot)
                end
            end
        end
    end


    for bag = BACKPACK_CONTAINER, NUM_BAG_SLOTS do
    local numberOfFreeSlots, bagType = GetContainerNumFreeSlots(bag)
        if numberOfFreeSlots > 0 then
        local currentBag = bag+19
            if currentBag == 19 then
                PutItemInBackpack()
                return
            else
                PutItemInBag(currentBag)
                return
            end
        end
    end
end

local function bankTransfer()
	if IsShiftKeyDown() then return end
    local itemsInBags = GetItemsInBags()
    local currentProfile = T.BankList
    local rightClickedItem = false
    local transferredToBank = false

    --  INVENTORY
    --
    for bag = NUM_BAG_SLOTS, BACKPACK_CONTAINER, -1 do
        for slot = GetContainerNumSlots(bag), 1, -1 do
        local _, itemCount, locked, _, _, _, itemLink, _, _, itemID = GetContainerItemInfo(bag, slot)
        local itemName = itemLink and string.match(itemLink, "%[(.*)%]")
            if itemID then
            local inList = IsItemInList(itemName)
                if not locked and inList then
                local item = currentProfile[GetItemIndex(itemName)]
                local numInBags = itemsInBags[item.itemName] or 0
                local Num = item.amount
                local difference = Num-numInBags
                    if difference < 0 then
                        UseContainerItem(bag, slot)
                        itemsInBags[item.itemName] = itemsInBags[item.itemName] and itemsInBags[item.itemName] - itemCount
                        rightClickedItem = true
                        transferredToBank = true
                        --coroutine.yield()
                    end
                end
            end -- if item we should get and its not locked
        end -- for slot
    end -- for bag


    --
    --  BANK
    --
    -- full stacks
    if not transferredToBank then
        for _, bag in ipairs(BANK_BAGS_REVERSED) do
            for slot = GetContainerNumSlots(bag), 1, -1 do
            local _, itemCount, locked, _, _, _, itemLink, _, _, itemID = GetContainerItemInfo(bag, slot)
            local itemName = itemLink and string.match(itemLink, "%[(.*)%]")
                if itemID and not locked then
                local inList = IsItemInList(itemName)
                    if not locked and inList then
                    local item = currentProfile[GetItemIndex(itemName)]
                    local numInBags = itemsInBags[item.itemName] or 0
                    local Num = item.amount
                    local difference = Num-numInBags
                        if difference > 0 and itemCount <= difference then
                            UseContainerItem(bag, slot)
                            itemsInBags[item.itemName] = itemsInBags[item.itemName] and itemsInBags[item.itemName] + itemCount or itemCount
                            rightClickedItem = true
                            --coroutine.yield()
                        end
                    end
                end -- if item we should get and its not locked
            end -- for slot
        end -- for bag
    end


    -- split stacks
    if not rightClickedItem then
        for _, bag in ipairs(BANK_BAGS_REVERSED) do
            for slot = GetContainerNumSlots(bag), 1, -1 do
            local _, itemCount, locked, _, _, _, itemLink, _, _, itemID = GetContainerItemInfo(bag, slot)
            local itemName = itemLink and string.match(itemLink, "%[(.*)%]")
                if itemID and not locked then
                local inList = IsItemInList(itemName)
                local itemStackSize = select(8, GetItemInfo(itemName))
                    if inList then
                    local item = currentProfile[GetItemIndex(itemName)]
                    local numInBags = itemsInBags[item.itemName] or 0
                    local Num = item.amount
                    local difference = Num-numInBags
                        if difference > 0 and itemCount > difference then
                            if mod(difference+numInBags, itemStackSize) == 0 then
                                -- if the amount we need creates a full stack in the inventory we simply have to pick up the item and place it on the incomplete stack in our inventory
                                -- if we split stacks here we get an error saying "couldn't split those items."
                                PickupContainerItem(bag, slot)
                            else
                                -- if the amount of items we need doesn't create a full stack then we split the stack in the bank and merge it with the one in our inventory.
                                SplitContainerItem(bag, slot, difference)
                            end
                            PutSplitItemIntoBags(item, difference)
                            itemsInBags[item.itemName] = itemsInBags[item.itemName] and itemsInBags[item.itemName] + difference or difference
                            --coroutine.yield()
                        end
                    end
                end -- if item we should get and its not locked
             end -- for slot
        end -- for bag
    end -- not right clicked an item
    if not (rightClickedItem == false and transferredToBank == false) then
       C_Timer.After(0.6, bankTransfer)
    end
end

local AutoBuy = CreateFrame("Frame")
AutoBuy:RegisterEvent("ADDON_LOADED")
AutoBuy:RegisterEvent("MERCHANT_SHOW")
AutoBuy:RegisterEvent("BANKFRAME_OPENED")
AutoBuy:SetScript("OnEvent",function(self,event)
    if event == "ADDON_LOADED" then
        T.BankList = {}
        for _, ItemId in pairs(T.buy_list) do
    		tinsert(T.BankList, {itemName = GetItemInfo(ItemId[1]), amount = ItemId[2]})
		end
    elseif event == "MERCHANT_SHOW" then
    	Buy()
    elseif event == "BANKFRAME_OPENED" then
        bankTransfer()
    end
end)
